# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .vendor_credit_line_account import VendorCreditLineAccount

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class VendorCreditLine(pydantic.BaseModel):
    """
    # The VendorCreditLine Object

    ### Description

    The `VendorCreditLine` object is used to represent a vendor credit's line items.

    ### Usage Example

    Fetch from the `GET VendorCredit` endpoint and view the vendor credit's line items.
    """

    id: typing.Optional[str]
    remote_id: typing.Optional[str] = pydantic.Field(description="The third-party API ID of the matching object.")
    created_at: typing.Optional[dt.datetime]
    modified_at: typing.Optional[dt.datetime] = pydantic.Field(
        description="This is the datetime that this object was last updated by Merge"
    )
    net_amount: typing.Optional[float] = pydantic.Field(description="The full value of the credit.")
    tracking_category: typing.Optional[str] = pydantic.Field(description="The line's associated tracking category.")
    tracking_categories: typing.List[str] = pydantic.Field(description="The line's associated tracking categories.")
    description: typing.Optional[str] = pydantic.Field(description="The line's description.")
    account: typing.Optional[VendorCreditLineAccount] = pydantic.Field(description="The line's account.")
    company: typing.Optional[str] = pydantic.Field(description="The company the line belongs to.")
    exchange_rate: typing.Optional[str] = pydantic.Field(description="The vendor credit line item's exchange rate.")
    remote_was_deleted: typing.Optional[bool] = pydantic.Field(
        description="Indicates whether or not this object has been deleted in the third party platform."
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
